
data <- read.csv("./3x3buff/foliarNref_wSRER.csv")
#rename columns from band# to wavelength
ref <- data[,12:437]
#create wavelengths for bands
lambda <- seq(385,2510, by=5)
lambda <- sub("$", "nm", lambda) 
colnames(ref) <- lambda

#calculate various published foliar N indicies
data$chen <- (ref$`720nm`-ref$`700nm`)/(ref$`700nm`-ref$`670nm`)/(ref$`720nm`-ref$`670nm`+0.03)
data$clevers <- (ref$`780nm`/ref$`710nm`)-1
data$reyniers <- ((1.45*(ref$`800nm`)^2)+1) / (ref$`670nm`+0.45)
data$ndni <- ((log(1/ref$`1510nm`))-(log(1/ref$`1680nm`))) / ((log(1/ref$`1510nm`))+(log(1/ref$`1680nm`)))
data$tian <- ref$`430nm`/(ref$`495nm`+ref$`400nm`)
data$wang <- (ref$`900nm`-ref$`700nm`+2*ref$`420nm`)/(ref$`900nm`+ref$`700nm`-2*ref$`420nm`)
data$wei1 <- (1.5*(ref$`820nm`-ref$`735nm`))/(ref$`820nm`+ref$`735nm`+0.5)
data$wei2 <- ref$`820nm`/ref$`735nm`
data$xue <- ref$`810nm`/ref$`560nm`
data$zhu1 <- ref$`950nm`/ref$`660nm`
data$zhu2 <- ref$`870nm`/ref$`660nm`
data$zhu3 <- ref$`810nm`/ref$`660nm`
##this analysis FNI##
data$ndvi <- (ref$`2050nm` - ref$`2095nm`)/(ref$`2050nm` + ref$`2095nm`)
data$savi <- (1.5 * (ref$`715nm` - ref$`1165nm`)) / (0.5 + ref$`715nm` + ref$`1165nm`)
data$rvi <- ref$`2050nm` / ref$`2095nm`
#calculate average NIR
data$nir <- rowMeans(ref[,84:94])

#subset dataset
regdata <- data #all samples
regdata <- subset(data, biome=="tropical") #subset x biome

#regdata$zhu3[is.infinite(regdata$zhu3)] <- NA

#regression analysis
reg1 <- lm(nir ~ ntrgnPr, data=regdata)
summary(reg1)
reg1